/////////////////////////////////////
//       
// ( )
/////////////////////////////////////

#include "Param.h"

// 
class CGauge  
{
public:
	CGauge();			//  
	virtual ~CGauge();	//   
	void Init(HWND hwnd,HIMAGELIST hil,int x,int y,int cx,int cy,int x_ind,int y_ind);
	void OnDraw(void);  //  
	void OnPaint(void); //  
	int m_Progress;		//   ( 0  100)
	BOOL m_Enabled;		
private:
	CRITICAL_SECTION m_cs; 
	double m_Position; //    
	int m_x_ind;// 
	int m_y_ind; // 
	int m_y;		// 
	int m_x;		// 
	int m_cy;		//
	int m_cx;		//
	HIMAGELIST m_hImageList; //    (  :   )
	HWND m_hwnd;	//   ,     
};

///////////////////////////////////////
// 
///////////////////////////////////////

CGauge::CGauge() 
{
	InitializeCriticalSection(&m_cs); //   
}

CGauge::~CGauge()
{
	DeleteCriticalSection(&m_cs); //   
}





void CGauge::OnDraw(void) //   
{
	EnterCriticalSection(&m_cs); //    

	m_Position=((double)(m_cx-m_x)/100)*((double)m_Progress); //  

	HDC hdc=GetDC(m_hwnd); //   
		
	HBRUSH hBrush	 = CreateSolidBrush(RGB(239,232,239));
	HBRUSH hOldBrush = SelectBrush(hdc,hBrush);
	Rectangle(hdc,m_x+(int)m_Position,m_y,m_cx,m_cy);
	SelectBrush(hdc,hOldBrush);
	DeleteBrush(hBrush);

	hBrush	  = CreateSolidBrush(RGB(144,160,176));
	hOldBrush = SelectBrush(hdc,hBrush);
	Rectangle(hdc,m_x,m_y,m_x+(int)m_Position,m_cy);
	SelectBrush(hdc,hOldBrush);
	DeleteBrush(hBrush);

	//   
	char sz[6];
	wsprintf(sz,TEXT("%d %%  "),(int)m_Progress);
	RECT rect={m_x,m_y+3,m_cx,m_cy};
	SetBkMode(hdc,TRANSPARENT); //   
	DrawText(hdc,sz,5,&rect,DT_CENTER|DT_VCENTER);

	ReleaseDC(m_hwnd,hdc); //  

	LeaveCriticalSection(&m_cs); //    
	return;
}

void CGauge::OnPaint(void)
{
	EnterCriticalSection(&m_cs);

	HDC hdc=GetDC(m_hwnd);
	
	OnDraw();

	//  
	if(m_Enabled)
		ImageList_Draw(m_hImageList,1,hdc,m_x_ind,m_y_ind,ILD_NORMAL);
	else ImageList_Draw(m_hImageList,0,hdc,m_x_ind,m_y_ind,ILD_NORMAL);
	
	ReleaseDC(m_hwnd,hdc);
	
	LeaveCriticalSection(&m_cs);
	return;
}


//    
void CGauge::Init(HWND hwnd,HIMAGELIST hil,int x,int y,int cx,int cy,int x_ind,int y_ind)
{
	m_hImageList = hil;
	m_Progress	 = 0;
	m_Position	 = 0;
	m_Enabled	 = FALSE;
	m_hwnd		 = hwnd;
	
	m_x	 = x;
	m_y	 = y;
	m_cx = cx;
	m_cy = cy;
	m_x_ind = x_ind;
	m_y_ind = y_ind;
	return;
}





