// OS.cpp : Defines the entry point for the application.
//

#include "Threads.h"
#include "resource.h"

#define MAX_LOADSTRING 100

#define ID_BUTTON_ABOUT 1003 //   About
#define ID_BUTTON_START 1004 //   Start
#define ID_UP_DOWN      1005 //   Start

TCHAR szTitle		[MAX_LOADSTRING];				
TCHAR szWindowClass	[MAX_LOADSTRING];		

//   CGauge
CGauge GaugeA,GaugeB,GaugeC,GaugeD,GaugeE,GaugeG,GaugeH,GaugeI;


HIMAGELIST	hImageListControl; //   ,      
HIMAGELIST	hImageList; //    
HINSTANCE	hInst;							
HWND		hWnd;

BOOL Selected1; //    
BOOL Selected2; //    
int UpDownValue=1; //  


ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM); //     
LRESULT CALLBACK    About(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam); //     " " 

void DrawBitmap(HDC hDC,int x,int y,HBITMAP hBitmap);
void DrawInterface(HDC hDC); //    (, )
void DrawItem(HWND hwnd,int number,int x,int y); //     
void DrawInformation(HDC hdc); //     
void AllStarts(void); //     


int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDS_MULTITHREADS, szWindowClass, MAX_LOADSTRING);
	
	if(!InitInstance(hInstance, nCmdShow)) return FALSE;

	hAccelTable = LoadAccelerators(hInstance,(LPCTSTR)IDS_MULTITHREADS);
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASS wc;
	wc.style			= CS_DBLCLKS;
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= LoadIcon(hInstance,(LPCTSTR)IDI_MAIN);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)CreateSolidBrush(RGB(127,152,176));
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= szWindowClass;
	return RegisterClass(&wc);
}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	int x=(GetSystemMetrics(SM_CXSCREEN)-450)/2;
	int y=(GetSystemMetrics(SM_CYSCREEN)-400)/2;

	MyRegisterClass(hInstance);

	hWnd = CreateWindow(
		szWindowClass,
		szTitle,
		WS_POPUPWINDOW|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_OVERLAPPED|WS_MINIMIZEBOX,//|WS_SYSMENU|WS_MINIMIZEBOX,
		x,y,450,400, 
		NULL,NULL,hInstance,NULL);
   	if(!hWnd)return FALSE;

	hInst=hInstance;

	InitCommonControls();
	
	HWND hUpDown=CreateUpDownControl(
	    WS_CHILD|WS_VISIBLE,
		422,100,10,20,
		hWnd,
		ID_UP_DOWN,
		hInst,
        hWnd, 	
		5, 	
		1, 	
		1);	

	//ShowWindow(hUpDown,nCmdShow);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}

//////////////////////////////////////////////
//   
//////////////////////////////////////////////

BOOL WndProc_OnCreate(HWND hwnd,LPCREATESTRUCT lpCreateStruct) 
{
	HWND hButton=CreateWindow(
		"BUTTON",
		" ",
		WS_CHILD|WS_VISIBLE,
		309,34,129,30,
		hwnd,
		(HMENU)ID_BUTTON_ABOUT,
		lpCreateStruct->hInstance,
		NULL);

	hButton=CreateWindow(
		"BUTTON",
		"",
		WS_CHILD|WS_VISIBLE,
		309,65,129,30,
		hwnd,
		(HMENU)ID_BUTTON_START,
		lpCreateStruct->hInstance,
		NULL);
	
	hListBox=CreateWindow(
		"LISTBOX",
		"",
		WS_CHILD|WS_VISIBLE|WS_BORDER|WS_VSCROLL|LBS_DISABLENOSCROLL	,
		14,30,285,150,
		hwnd,
		NULL,
		lpCreateStruct->hInstance,
		NULL);

	hImageList=ImageList_Create(26,26,ILC_COLOR16|ILC_MASK,2,1);
	
	//   
	HBITMAP hBitmap;
	
	hBitmap=LoadBitmap(lpCreateStruct->hInstance,MAKEINTRESOURCE(IDB_STOP));
	ImageList_AddMasked(hImageList,hBitmap,RGB(255,255,255));
	DeleteObject(hBitmap);

    hBitmap=LoadBitmap(lpCreateStruct->hInstance,MAKEINTRESOURCE(IDB_START));
	ImageList_AddMasked(hImageList,hBitmap,RGB(255,255,255));
	DeleteObject(hBitmap);

	hImageListControl=ImageList_Create(21,21,ILC_COLOR16|ILC_MASK,2,1);
	
	for(int temp=IDB_BITMAP1;temp<=IDB_BITMAP4;temp++)
	{
	hBitmap=LoadBitmap(lpCreateStruct->hInstance,MAKEINTRESOURCE(temp));
	ImageList_AddMasked(hImageListControl,hBitmap,RGB(0,0,255));
	DeleteObject(hBitmap);
	}
	
	//   
	GaugeA.Init(hwnd,hImageList,14,179,270,201,272,177);
	GaugeB.Init(hwnd,hImageList,14,206,270,228,272,204);
	GaugeC.Init(hwnd,hImageList,14,233,270,255,272,231);
	GaugeD.Init(hwnd,hImageList,14,260,270,282,272,258);
	GaugeE.Init(hwnd,hImageList,14,287,270,309,272,285);
	GaugeG.Init(hwnd,hImageList,14,314,270,336,272,312);
	GaugeH.Init(hwnd,hImageList,14,341,270,363,272,339);
	GaugeI.Init(hwnd,hImageList,14,368,270,390,272,366);

	InitializeCriticalSection(&g_cs);

	ShowWindow(hwnd,SW_SHOW);
	return TRUE;
}


void WndProc_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify) 
{
	switch(id)
	{
	case ID_BUTTON_ABOUT:
		{
			DialogBox(hInst,(LPCTSTR)IDD_DIALOG1,hWnd,(DLGPROC)About);
		}
		break;
	case ID_BUTTON_START:
		{
			if(!IsPush)
			{
				SendMessage(hListBox,LB_RESETCONTENT,0,0);
				AllStarts();
			}
			else MessageBox(hwnd," ","",MB_OK|MB_ICONSTOP);
		}
		break;
	}
	return;
}

LRESULT WndProc_OnNotify(HWND hwnd,int idFrom,NMHDR* pnmhdr) 
{
	switch(idFrom)
	{
		case ID_UP_DOWN:
		{
			switch(pnmhdr->code)
			{
				case UDN_DELTAPOS: 
				{
					UpDownValue=((NM_UPDOWN *)pnmhdr)->iPos;
					UpDownValue+=((NM_UPDOWN *)pnmhdr)->iDelta;
					switch(UpDownValue)
					{
					case 0: UpDownValue=1; break;
					case 6: UpDownValue=5; break;
					};
					
					HDC hdc=GetDC(hwnd);
					wsprintf(sz,"%d",UpDownValue);
					TextOut(hdc,395,101,sz,1);
					ReleaseDC(hwnd,hdc);
				}
				break;
			}
		}
		break;
	}
	FORWARD_WM_NOTIFY(hwnd,idFrom,pnmhdr,DefWindowProc);
	return 0;
}



void WndProc_OnLButtonDown(HWND hwnd,BOOL fDoubleClick,int x,int y,UINT keyFlags) 
{	
	//       
	if((y<=23)&&(y>2))
	{
		if((x>396)&&(x<417))
		{
			DrawItem(hwnd,1,396,2);
			Selected1=TRUE;
			return;
		}
		
		if((x>420)&&(x<441))
		{
			DrawItem(hwnd,3,420,2);
			Selected2=TRUE;
			return;
		}
	}

	//    
	if(y<26)
	{
		ReleaseCapture();
 		SendMessage(hwnd,WM_SYSCOMMAND,SC_MOVE|HTCAPTION,0);
	}
	return;
}


void WndProc_OnLButtonUp(HWND hwnd,int x,int y,UINT keyFlags) 
{
	//        
	if((y<=23)&&(y>2))
	{
		if((x>396)&&(x<417)) ShowWindow(hwnd,SW_MINIMIZE);
		if((x>420)&&(x<441)) DestroyWindow(hwnd);
	}
	return;
}


void WndProc_OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags) 
{
	if(Selected1) 
		if((!((x>396)&&(x<417)))||(!((y<=23)&&(y>2))))
		{
			DrawItem(hwnd,0,396,2);
			Selected1=FALSE;	
		}
		
	if(Selected2)
		if((!((x>420)&&(x<441)))||(!((y<=23)&&(y>2))))
		{
			DrawItem(hwnd,2,420,2);
			Selected2=FALSE;	
		}
	return;
}


//   
void WndProc_OnPaint(HWND hwnd)
{	
	HDC hdc;
	PAINTSTRUCT ps;
	
	hdc=BeginPaint(hwnd,&ps);
	
	DrawInterface(hdc);	
	DrawInformation(hdc);

	ImageList_Draw(hImageListControl,0,hdc,396,2,ILD_NORMAL);
	ImageList_Draw(hImageListControl,2,hdc,420,2,ILD_NORMAL);

	GaugeA.OnPaint();
	GaugeB.OnPaint();
	GaugeC.OnPaint();
	GaugeD.OnPaint();
	GaugeE.OnPaint();
	GaugeG.OnPaint();
	GaugeH.OnPaint();
	GaugeI.OnPaint();

	EndPaint(hwnd,&ps);

	FORWARD_WM_PAINT(hwnd,DefWindowProc);
}

void WndProc_OnDestroy(HWND hwnd)
{
	DeleteCriticalSection(&g_cs);
	ImageList_Destroy(hImageListControl);
	ImageList_Destroy(hImageList);
	PostQuitMessage(0);
	return;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
		HANDLE_MSG(hwnd,WM_CREATE,WndProc_OnCreate);
		HANDLE_MSG(hwnd,WM_COMMAND,WndProc_OnCommand);
		HANDLE_MSG(hwnd,WM_NOTIFY,WndProc_OnNotify);
		HANDLE_MSG(hwnd,WM_DESTROY,WndProc_OnDestroy);
		HANDLE_MSG(hwnd,WM_PAINT,WndProc_OnPaint);
		HANDLE_MSG(hwnd,WM_LBUTTONDOWN,WndProc_OnLButtonDown);
		HANDLE_MSG(hwnd,WM_LBUTTONUP,WndProc_OnLButtonUp);
		HANDLE_MSG(hwnd,WM_MOUSEMOVE,WndProc_OnMouseMove);
		default:
			return DefWindowProc(hwnd, message, wParam, lParam);
   }
   return 0;
}

LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam)==IDOK) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}



void DrawInterface(HDC hDC) 
{  
	HBITMAP hOldbm,hBitmap;
	BITMAP bm;
	HDC hMemDC;

	hBitmap= LoadBitmap(hInst,MAKEINTRESOURCE(IDB_INTERFACE));
	hMemDC = CreateCompatibleDC(hDC);
	hOldbm = (HBITMAP)SelectObject(hMemDC, hBitmap);
	
	GetObject(hBitmap,sizeof(BITMAP),(LPSTR)&bm);
	
	int x;
	for(x=0;x<300;x++) 
		BitBlt(hDC,x,0,1,25,hMemDC,0,0,SRCCOPY); 
	BitBlt(hDC,300,0,6,25,hMemDC,1,0,SRCCOPY); 
	for(x=306;x<449;x++) 
		BitBlt(hDC,x,0,1,25,hMemDC,7,0,SRCCOPY); 

	SetBkMode(hDC,TRANSPARENT);	
	TextOut(hDC,10,4,"OS2",3);
	
	int y;
	for(y=26;y<394;y++)
	{
		BitBlt(hDC,0  ,y,4,1,hMemDC,0,25,SRCCOPY); 
		BitBlt(hDC,444,y,4,1,hMemDC,4,25,SRCCOPY); 
	}
	
	BitBlt(hDC,0  ,394,4,4,hMemDC,0,26,SRCCOPY); 
	BitBlt(hDC,444,394,4,4,hMemDC,4,26,SRCCOPY); 
	
	for(x=4;x<444;x++)
		BitBlt(hDC,x,394,1,4,hMemDC,0,26,SRCCOPY); 

	MoveToEx(hDC,0,25,NULL);
	LineTo(hDC,450,25);
	MoveToEx(hDC,4,25,NULL);
	LineTo(hDC,4,393);
	LineTo(hDC,443,393);
	LineTo(hDC,443,25);

	SelectObject(hMemDC, hOldbm);
	DeleteObject(hBitmap);
	DeleteDC(hMemDC);
}


void DrawItem(HWND hwnd,int number,int x,int y)
{
	HDC hdc=GetDC(hwnd);
	ImageList_Draw(hImageListControl,number,hdc,x,y,ILD_NORMAL);
	Selected1=FALSE;
	ReleaseDC(hwnd,hdc);
	return;
}

void DrawInformation(HDC hdc)
{
	char str[24];

	SetBkMode(hdc,TRANSPARENT);	
	int number=IDS_THREAD1;
    for (int nRow=0;nRow <= 7; nRow++)
	{ 
		LoadString(hInst,number,str,sizeof(str)); 
		TextOut(hdc,320,182+nRow*27,str,7);
		number++;
    } 
	Rectangle(hdc,309,100,421,120);
	LoadString(hInst,IDS_DELAY,str,sizeof(str)); 
	TextOut(hdc,312,101,str,9);
	wsprintf(sz,"%d",UpDownValue);
	TextOut(hdc,395,101,sz,1);
	return;
}

///////////////////////////////////////
//   
///////////////////////////////////////

void AllStarts(void)
{
	switch(UpDownValue)
	{
		case 1: DelayOfThreadProc=1000; break;
		case 2: DelayOfThreadProc=5000; break;
		case 3: DelayOfThreadProc=15000; break;
		case 4: DelayOfThreadProc=40000; break;
		case 5: DelayOfThreadProc=60000; break;
	}
	

	IsPush=TRUE;
	TParams Params;

	Params.Length=2;
	Params.OwnName='A';
	Params.ParentName='-';
	Params.ZType=1;
	Params.Priority=20;

	ThreadA.Create(&Params,&GaugeA);
	 
	Params.Length=3;
	Params.OwnName='B';
	Params.ParentName='-';
	Params.ZType=2;
	Params.Priority=45;

	ThreadB.Create(&Params,&GaugeB);

	Params.Length=2;
	Params.OwnName='C';
	Params.ParentName='A';
	Params.ZType=3;
	Params.Priority=70;

	ThreadC.Create(&Params,&GaugeC);
	
	Params.Length=1;
	Params.OwnName='D';
	Params.ParentName='A';
	Params.ZType=3;
	Params.Priority=75;

	ThreadD.Create(&Params,&GaugeD);
	 	 
	Params.Length=2;
	Params.OwnName='E';
	Params.ParentName='C';
	Params.ZType=1;
	Params.Priority=5;

	ThreadE.Create(&Params,&GaugeE);
	 
	Params.Length=2;
	Params.OwnName='G';
	Params.ParentName='E';
	Params.ZType=1;
	Params.Priority=5;

	ThreadG.Create(&Params,&GaugeG);
	 
	Params.Length=1;
	Params.OwnName='H';
	Params.ParentName='C';
	Params.ZType=2;
	Params.Priority=45;

	ThreadH.Create(&Params,&GaugeH);
	 
	Params.Length=2;
	Params.OwnName='I';
	Params.ParentName='G';
	Params.ZType=3;
	Params.Priority=55;

	ThreadI.Create(&Params,&GaugeI);

	ThreadA.Resume();
	ThreadB.Resume();
	return;
}



